diff --git a/doc/guides/sample_app_ug/exception_path.rst b/doc/guides/sample_app_ug/exception_path.rst
index 3cc7cbe..c3f8f88 100644
--- a/doc/guides/sample_app_ug/exception_path.rst
+++ b/doc/guides/sample_app_ug/exception_path.rst
@@ -173,7 +173,7 @@ The code for creating the TAP interface is as follows:
         }
 
         if (name)
-            rte_snprintf(name, IFNAMSIZ, ifr.ifr_name);
+            snprintf(name, IFNAMSIZ, ifr.ifr_name);
 
         return fd;
     }
diff --git a/doc/guides/sample_app_ug/ip_reassembly.rst b/doc/guides/sample_app_ug/ip_reassembly.rst
index 050802a..6bf5938 100644
--- a/doc/guides/sample_app_ug/ip_reassembly.rst
+++ b/doc/guides/sample_app_ug/ip_reassembly.rst
@@ -223,7 +223,7 @@ each RX queue uses its own mempool.
     nb_mbuf += RTE_TEST_RX_DESC_DEFAULT + RTE_TEST_TX_DESC_DEFAULT;
     nb_mbuf = RTE_MAX(nb_mbuf, (uint32_t)NB_MBUF);
 
-    rte_snprintf(buf, sizeof(buf), "mbuf_pool_%u_%u", lcore, queue);
+    snprintf(buf, sizeof(buf), "mbuf_pool_%u_%u", lcore, queue);
 
     if ((rxq->pool = rte_mempool_create(buf, nb_mbuf, MBUF_SIZE, 0, sizeof(struct rte_pktmbuf_pool_private), rte_pktmbuf_pool_init, NULL,
         rte_pktmbuf_init, NULL, socket, MEMPOOL_F_SP_PUT | MEMPOOL_F_SC_GET)) == NULL) {
diff --git a/doc/guides/sample_app_ug/kernel_nic_interface.rst b/doc/guides/sample_app_ug/kernel_nic_interface.rst
index c8fc10a..985c664 100644
--- a/doc/guides/sample_app_ug/kernel_nic_interface.rst
+++ b/doc/guides/sample_app_ug/kernel_nic_interface.rst
@@ -265,11 +265,11 @@ The code for allocating the kernel NIC interfaces for a specific port is as foll
 
             memset(&conf, 0, sizeof(conf));
             if (params[port_id]->nb_lcore_k) {
-                rte_snprintf(conf.name, RTE_KNI_NAMESIZE, "vEth%u_%u", port_id, i);
+                snprintf(conf.name, RTE_KNI_NAMESIZE, "vEth%u_%u", port_id, i);
                 conf.core_id = params[port_id]->lcore_k[i];
                 conf.force_bind = 1;
             } else
-                rte_snprintf(conf.name, RTE_KNI_NAMESIZE, "vEth%u", port_id);
+                snprintf(conf.name, RTE_KNI_NAMESIZE, "vEth%u", port_id);
                 conf.group_id = (uint16_t)port_id;
                 conf.mbuf_size = MAX_PACKET_SZ;
 
@@ -352,7 +352,7 @@ The code is as follows:
                 goto fail;
             }
 
-            rte_snprintf(s, sizeof(s), "%.*s", size, p);
+            snprintf(s, sizeof(s), "%.*s", size, p);
             nb_token = rte_strsplit(s, sizeof(s), str_fld, _NUM_FLD, ',');
 
             if (nb_token <= FLD_LCORE_TX) {
diff --git a/doc/guides/sample_app_ug/l3_forward.rst b/doc/guides/sample_app_ug/l3_forward.rst
index 34a84f1..4ce734b 100644
--- a/doc/guides/sample_app_ug/l3_forward.rst
+++ b/doc/guides/sample_app_ug/l3_forward.rst
@@ -233,7 +233,7 @@ The LPM object is created and loaded with the pre-configured entries read from a
 
         /* create the LPM table */
 
-        rte_snprintf(s, sizeof(s), "IPV4_L3FWD_LPM_%d", socketid);
+        snprintf(s, sizeof(s), "IPV4_L3FWD_LPM_%d", socketid);
 
         ipv4_l3fwd_lookup_struct[socketid] = rte_lpm_create(s, socketid, IPV4_L3FWD_LPM_MAX_RULES, 0);
 
diff --git a/examples/l3fwd-power/main.c b/examples/l3fwd-power/main.c
index 9175989..828c18a 100644
--- a/examples/l3fwd-power/main.c
+++ b/examples/l3fwd-power/main.c
@@ -1373,7 +1373,7 @@ setup_hash(int socketid)
 	char s[64];
 
 	/* create ipv4 hash */
-	rte_snprintf(s, sizeof(s), "ipv4_l3fwd_hash_%d", socketid);
+	snprintf(s, sizeof(s), "ipv4_l3fwd_hash_%d", socketid);
 	ipv4_l3fwd_hash_params.name = s;
 	ipv4_l3fwd_hash_params.socket_id = socketid;
 	ipv4_l3fwd_lookup_struct[socketid] =
@@ -1383,7 +1383,7 @@ setup_hash(int socketid)
 				"socket %d\n", socketid);
 
 	/* create ipv6 hash */
-	rte_snprintf(s, sizeof(s), "ipv6_l3fwd_hash_%d", socketid);
+	snprintf(s, sizeof(s), "ipv6_l3fwd_hash_%d", socketid);
 	ipv6_l3fwd_hash_params.name = s;
 	ipv6_l3fwd_hash_params.socket_id = socketid;
 	ipv6_l3fwd_lookup_struct[socketid] =
diff --git a/lib/librte_eal/bsdapp/eal/rte_eal_version.map b/lib/librte_eal/bsdapp/eal/rte_eal_version.map
index 7a88387..9d7adf1 100644
--- a/lib/librte_eal/bsdapp/eal/rte_eal_version.map
+++ b/lib/librte_eal/bsdapp/eal/rte_eal_version.map
@@ -94,7 +94,6 @@ DPDK_2.0 {
 	rte_set_application_usage_hook;
 	rte_set_log_level;
 	rte_set_log_type;
-	rte_snprintf;
 	rte_socket_id;
 	rte_strerror;
 	rte_strsplit;
@@ -106,7 +105,6 @@ DPDK_2.0 {
 	rte_xen_dom0_memory_init;
 	rte_zmalloc;
 	rte_zmalloc_socket;
-	test_mp_secondary;
 
 	local: *;
 };
diff --git a/lib/librte_eal/linuxapp/eal/rte_eal_version.map b/lib/librte_eal/linuxapp/eal/rte_eal_version.map
index 828496f..cbe175f 100644
--- a/lib/librte_eal/linuxapp/eal/rte_eal_version.map
+++ b/lib/librte_eal/linuxapp/eal/rte_eal_version.map
@@ -94,7 +94,6 @@ DPDK_2.0 {
 	rte_set_application_usage_hook;
 	rte_set_log_level;
 	rte_set_log_type;
-	rte_snprintf;
 	rte_socket_id;
 	rte_strerror;
 	rte_strsplit;
@@ -106,7 +105,6 @@ DPDK_2.0 {
 	rte_xen_dom0_memory_init;
 	rte_zmalloc;
 	rte_zmalloc_socket;
-	test_mp_secondary;
 
 	local: *;
 };